/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  LowLim
  Package: impl
  File:    LowLim.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;

/**
  LowLim
  
  Defines the lower limit of range.
*/
class LowLim
  extends Composite {

  /**
  */
  public LowLim() {
  
  //+ LowLim::LowLim( )
    super();
  //- LowLim::LowLim( )
  }
  
  /**
  */
  public boolean check(Component addition)
    throws IllegalStateException  {
  
  //+ LowLim::check(Component)
      if (!(addition instanceof Gte) &&
	  !(addition instanceof ByteString &&
	    !addition.getClass().getSuperclass().getName().equals
	    ((new ByteString()).getClass().getName())))
	return false;
      if ((children.size() == 0) &&
	  (addition instanceof Gte))
	return true;
      if ((children.size() == 1) &&
	  (addition instanceof ByteString))
	return true;
      throw new IllegalStateException();
  //- LowLim::check(Component)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ LowLim::accept(Visitor)
    visitor.at(this);
  //- LowLim::accept(Visitor)
  }
  
} // LowLim

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
