/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  HashOp
  Package: impl
  File:    HashOp.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;
import fi.hut.tcm.spki.format.*;

/**
  HashOp
  
  Order for a Hash-operation. Contains a HashAlgName.
*/
public class HashOp
  extends Composite
  implements Op, SeqEnt, fi.hut.tcm.spki.Composite, Component {

  /**
  */
  public HashOp() {
  
  //+ HashOp::HashOp( )
    super();
  //- HashOp::HashOp( )
  }
  
  /**
  */
  public boolean check(Component addition)
    throws IllegalStateException  {
  
  //+ HashOp::check(Component)
      if (!(addition instanceof HashAlgName))
	return false;
      if (children.size() == 0)
	return true;
      throw new IllegalStateException();
  //- HashOp::check(Component)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ HashOp::accept(Visitor)
    visitor.at(this);
  //- HashOp::accept(Visitor)
  }
  
} // HashOp

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
