/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  NotBefore
  Package: impl
  File:    NotBefore.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;

/**
  NotBefore
  
  The time indicating the start of the validity period. Contains a Time-
  object.
*/
public class NotBefore
  extends Composite {

  /**
  */
  public NotBefore() {
  
  //+ NotBefore::NotBefore( )
    super();
  //- NotBefore::NotBefore( )
  }
  
  /**
  */
  public boolean check(Component addition)
    throws IllegalStateException  {
  
  //+ NotBefore::check(Component)
      if (!(addition instanceof Time))
	return false;
      if (children.size() == 0)
	return true;
      throw new IllegalStateException();
  //- NotBefore::check(Component)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ NotBefore::accept(Visitor)
    visitor.at(this);
  //- NotBefore::accept(Visitor)
  }
  
} // NotBefore

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
