/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  TagSet
  Package: impl
  File:    TagSet.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;

/**
  TagSet
  
  TagSet defines an explicit set of TagExprs (which may contain TagRanges 
  and TagPrefixes, though).
*/
public class TagSet
  extends Composite {

  /**
  */
  public TagSet() {
  
  //+ TagSet::TagSet( )
    super();
  //- TagSet::TagSet( )
  }
  
  /**
  */
  public boolean check(Component addition) {
  
  //+ TagSet::check(Component)
      return (addition instanceof TagExpr);
  //- TagSet::check(Component)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ TagSet::accept(Visitor)
      visitor.at(this);
  //- TagSet::accept(Visitor)
  }
  
} // TagSet

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
